| template-haskell-2.2.0.0 | Source code | Contents | Index

Language.Haskell.TH.Syntax

Portability | portable
Stability | experimental
Maintainer | libraries@haskell.org

Description
Abstract syntax definitions for Template Haskell.
Synopsis

class (Monad m, Functor m) => Quasi m where

qNewName :: String -> m Name
qReport :: Bool -> String -> m ()
qRecover :: m a -> m a -> m a
qReify :: Name -> m Info
qCurrentModule :: m String
qRunIO :: IO a -> m a

class Lift t where

lift :: t -> Q Exp

data Q a
runQ :: Quasi m => Q a -> m a
report :: Bool -> String -> Q ()
recover :: Q a -> Q a -> Q a
reify :: Name -> Q Info
currentModule :: Q String
runIO :: IO a -> Q a
data Name = Name OccName NameFlavour
mkName :: String -> Name
newName :: String -> Q Name
nameBase :: Name -> String
nameModule :: Name -> Maybe String
showName :: Name -> String
showName' :: NameIs -> Name -> String

data NameIs

= Alone
| Applied
| Infix

data Dec

= FunD Name [Clause]
| ValD Pat Body [Dec]
| DataD Cxt Name [Name] [Con] [Name]
| NewtypeD Cxt Name [Name] Con [Name]
| TySynD Name [Name] Type
| ClassD Cxt Name [Name] [FunDep] [Dec]
| InstanceD Cxt Type [Dec]
| SigD Name Type
| ForeignD Foreign

data Exp

= VarE Name
| ConE Name
| LitE Lit
| AppE Exp Exp
| InfixE (Maybe Exp) Exp (Maybe Exp)
| LamE [Pat] Exp
| TupE [Exp]
| CondE Exp Exp Exp
| LetE [Dec] Exp
| CaseE Exp [Match]
| DoE [Stmt]
| CompE [Stmt]
| ArithSeqE Range
| ListE [Exp]
| SigE Exp Type
| RecConE Name [FieldExp]
| RecUpdE Exp [FieldExp]

data Con

= NormalC Name [StrictType]
| RecC Name [VarStrictType]
| InfixC StrictType Name StrictType
| ForallC [Name] Cxt Con

data Type

= ForallT [Name] Cxt Type
| VarT Name
| ConT Name
| TupleT Int
| ArrowT
| ListT
| AppT Type Type

type Cxt = [Type]
data Match = Match Pat Body [Dec]
data Clause = Clause [Pat] Body [Dec]

data Body

= GuardedB [(Guard, Exp)]
| NormalB Exp

data Guard

= NormalG Exp
| PatG [Stmt]

data Stmt

= BindS Pat Exp
| LetS [Dec]
| NoBindS Exp
| ParS [[Stmt]]

data Range

= FromR Exp
| FromThenR Exp Exp
| FromToR Exp Exp
| FromThenToR Exp Exp Exp

data Lit

= CharL Char
| StringL String
| IntegerL Integer
| RationalL Rational
| IntPrimL Integer
| FloatPrimL Rational
| DoublePrimL Rational

data Pat

= LitP Lit
| VarP Name
| TupP [Pat]
| ConP Name [Pat]
| InfixP Pat Name Pat
| TildeP Pat
| AsP Name Pat
| WildP
| RecP Name [FieldPat]
| ListP [Pat]
| SigP Pat Type

type FieldExp = (Name, Exp)
type FieldPat = (Name, Pat)

data Strict

= IsStrict
| NotStrict

data Foreign

= ImportF Callconv Safety String Name Type
| ExportF Callconv String Name Type

data Callconv

= CCall
| StdCall

data Safety

= Unsafe
| Safe
| Threadsafe

type StrictType = (Strict, Type)
type VarStrictType = (Name, Strict, Type)
data FunDep = FunDep [Name] [Name]

data Info

= ClassI Dec
| ClassOpI Name Type Name Fixity
| TyConI Dec
| PrimTyConI Name Int Bool
| DataConI Name Type Name Fixity
| VarI Name Type (Maybe Dec) Fixity
| TyVarI Name Type

data Fixity = Fixity Int FixityDirection

data FixityDirection

= InfixL
| InfixR
| InfixN

defaultFixity :: Fixity
maxPrecedence :: Int
returnQ :: a -> Q a
bindQ :: Q a -> (a -> Q b) -> Q b
sequenceQ :: [Q a] -> Q [a]

data NameFlavour

= NameS
| NameQ ModName
| NameU Int#
| NameL Int#
| NameG NameSpace PkgName ModName

data NameSpace

= VarName
| DataName
| TcClsName

mkNameG_v :: String -> String -> String -> Name
mkNameG_d :: String -> String -> String -> Name
mkNameG_tc :: String -> String -> String -> Name
type Uniq = Int
mkNameL :: String -> Uniq -> Name
mkNameU :: String -> Uniq -> Name
tupleTypeName :: Int -> Name
tupleDataName :: Int -> Name
type OccName = PackedString
mkOccName :: String -> OccName
occString :: OccName -> String
type ModName = PackedString
mkModName :: String -> ModName
modString :: ModName -> String
type PkgName = PackedString
mkPkgName :: String -> PkgName
pkgString :: PkgName -> String

Documentation

class (Monad m, Functor m) => Quasi m where | Source

Methods

qNewName :: String -> m Name | Source

qReport :: Bool -> String -> m () | Source

qRecover :: m a -> m a -> m a | Source

qReify :: Name -> m Info | Source

qCurrentModule :: m String | Source

qRunIO :: IO a -> m a | Source

Instances

Quasi IO
Quasi Q

class Lift t where | Source

Methods

lift :: t -> Q Exp | Source

Instances

Lift Bool
Lift Char
Lift Int
Lift Integer
(Lift a, Lift b) => Lift (a, b)
(Lift a, Lift b, Lift c) => Lift (a, b, c)
(Lift a, Lift b, Lift c, Lift d) => Lift (a, b, c, d)
(Lift a, Lift b, Lift c, Lift d, Lift e) => Lift (a, b, c, d, e)
(Lift a, Lift b, Lift c, Lift d, Lift e, Lift f) => Lift (a, b, c, d, e, f)
(Lift a, Lift b, Lift c, Lift d, Lift e, Lift f, Lift g) => Lift (a, b, c, d, e, f, g)
Lift a => Lift (Maybe a)
Lift a => Lift [a]
(Lift a, Lift b) => Lift (Either a b)

data Q a | Source

Instances

Functor Q
Monad Q
Quasi Q

runQ :: Quasi m => Q a -> m a | Source

report :: Bool -> String -> Q () | Source

recover :: Q a -> Q a -> Q a | Source

reify :: Name -> Q Info | Source

`reify` looks up information about the `Name`

currentModule :: Q String | Source

`currentModule` gives you the name of the module in which this computation is spliced.

runIO :: IO a -> Q a | Source

The `runIO` function lets you run an I/O computation in the `Q` monad. Take care: you are guaranteed the ordering of calls to `runIO` within a single `Q` computation, but not about the order in which splices are run. Note: for various murky reasons, stdout and stderr handles are not necesarily flushed when the compiler finishes running, so you should flush them yourself.

data Name | Source

Constructors

Name OccName NameFlavour |

Instances

Data Name
Eq Name
Ord Name
Ppr Name
Show Name
Typeable Name

mkName :: String -> Name | Source

newName :: String -> Q Name | Source

nameBase :: Name -> String | Source

nameModule :: Name -> Maybe String | Source

showName :: Name -> String | Source

showName' :: NameIs -> Name -> String | Source

data NameIs | Source

Constructors

Alone |
Applied |
Infix |

data Dec | Source

Constructors

FunD Name [Clause] |
ValD Pat Body [Dec] |
DataD Cxt Name [Name] [Con] [Name] |
NewtypeD Cxt Name [Name] Con [Name] |
TySynD Name [Name] Type |
ClassD Cxt Name [Name] [FunDep] [Dec] |
InstanceD Cxt Type [Dec] |
SigD Name Type |
ForeignD Foreign |

Instances

Data Dec
Eq Dec
Ppr Dec
Show Dec
Typeable Dec

data Exp | Source

Constructors

VarE Name |
ConE Name |
LitE Lit |
AppE Exp Exp |
InfixE (Maybe Exp) Exp (Maybe Exp) |
LamE [Pat] Exp |
TupE [Exp] |
CondE Exp Exp Exp |
LetE [Dec] Exp |
CaseE Exp [Match] |
DoE [Stmt] |
CompE [Stmt] |
ArithSeqE Range |
ListE [Exp] |
SigE Exp Type |
RecConE Name [FieldExp] |
RecUpdE Exp [FieldExp] |

Instances

Data Exp
Eq Exp
Ppr Exp
Show Exp
Typeable Exp

data Con | Source

Constructors

NormalC Name [StrictType] |
RecC Name [VarStrictType] |
InfixC StrictType Name StrictType |
ForallC [Name] Cxt Con |

Instances

Data Con
Eq Con
Ppr Con
Show Con
Typeable Con

data Type | Source

Constructors

ForallT [Name] Cxt Type |
VarT Name |
ConT Name |
TupleT Int |
ArrowT |
ListT |
AppT Type Type |

Instances

Data Type
Eq Type
Ppr Type
Show Type
Typeable Type

type Cxt = [Type] | Source

data Match | Source

Constructors

Match Pat Body [Dec] |

Instances

Data Match
Eq Match
Ppr Match
Show Match
Typeable Match

data Clause | Source

Constructors

Clause [Pat] Body [Dec] |

Instances

Data Clause
Eq Clause
Ppr Clause
Show Clause
Typeable Clause

data Body | Source

Constructors

GuardedB [(Guard, Exp)] |
NormalB Exp |

Instances

Data Body
Eq Body
Show Body
Typeable Body

data Guard | Source

Constructors

NormalG Exp |
PatG [Stmt] |

Instances

Data Guard
Eq Guard
Show Guard
Typeable Guard

data Stmt | Source

Constructors

BindS Pat Exp |
LetS [Dec] |
NoBindS Exp |
ParS [[Stmt]] |

Instances

Data Stmt
Eq Stmt
Ppr Stmt
Show Stmt
Typeable Stmt

data Range | Source

Constructors

FromR Exp |
FromThenR Exp Exp |
FromToR Exp Exp |
FromThenToR Exp Exp Exp |

Instances

Data Range
Eq Range
Ppr Range
Show Range
Typeable Range

data Lit | Source

Constructors

CharL Char |
StringL String |
IntegerL Integer |
RationalL Rational |
IntPrimL Integer |
FloatPrimL Rational |
DoublePrimL Rational |

Instances

Data Lit
Eq Lit
Show Lit
Typeable Lit

data Pat | Source

Constructors

LitP Lit |
VarP Name |
TupP [Pat] |
ConP Name [Pat] |
InfixP Pat Name Pat |
TildeP Pat |
AsP Name Pat |
WildP |
RecP Name [FieldPat] |
ListP [Pat] |
SigP Pat Type |

Instances

Data Pat
Eq Pat
Ppr Pat
Show Pat
Typeable Pat

type FieldExp = (Name, Exp) | Source

type FieldPat = (Name, Pat) | Source

data Strict | Source

Constructors

IsStrict |
NotStrict |

Instances

Data Strict
Eq Strict
Show Strict
Typeable Strict

data Foreign | Source

Constructors

ImportF Callconv Safety String Name Type |
ExportF Callconv String Name Type |

Instances

Data Foreign
Eq Foreign
Ppr Foreign
Show Foreign
Typeable Foreign

data Callconv | Source

Constructors

CCall |
StdCall |

Instances

Data Callconv
Eq Callconv
Show Callconv
Typeable Callconv

data Safety | Source

Constructors

Unsafe |
Safe |
Threadsafe |

Instances

Data Safety
Eq Safety
Show Safety
Typeable Safety

type StrictType = (Strict, Type) | Source

type VarStrictType = (Name, Strict, Type) | Source

data FunDep | Source

Constructors

FunDep [Name] [Name] |

Instances

Data FunDep
Eq FunDep
Ppr FunDep
Show FunDep
Typeable FunDep

data Info | Source

Constructors

ClassI Dec |
ClassOpI Name Type Name Fixity |
TyConI Dec |
PrimTyConI Name Int Bool |
DataConI Name Type Name Fixity |
VarI Name Type (Maybe Dec) Fixity |
TyVarI Name Type |

Instances

Data Info
Ppr Info
Show Info
Typeable Info

data Fixity | Source

Constructors

Fixity Int FixityDirection |

Instances

Data Fixity
Eq Fixity
Show Fixity
Typeable Fixity

data FixityDirection | Source

Constructors

InfixL |
InfixR |
InfixN |

Instances

Data FixityDirection
Eq FixityDirection
Show FixityDirection
Typeable FixityDirection

defaultFixity :: Fixity | Source

maxPrecedence :: Int | Source

returnQ :: a -> Q a | Source

bindQ :: Q a -> (a -> Q b) -> Q b | Source

sequenceQ :: [Q a] -> Q [a] | Source

data NameFlavour | Source

Constructors

NameS |
NameQ ModName |
NameU Int# |
NameL Int# |
NameG NameSpace PkgName ModName |

Instances

Data NameFlavour
Eq NameFlavour
Ord NameFlavour
Typeable NameFlavour

data NameSpace | Source

Constructors

VarName |
DataName |
TcClsName |

Instances

Data NameSpace
Eq NameSpace
Ord NameSpace
Typeable NameSpace

mkNameG_v :: String -> String -> String -> Name | Source

mkNameG_d :: String -> String -> String -> Name | Source

mkNameG_tc :: String -> String -> String -> Name | Source

type Uniq = Int | Source

mkNameL :: String -> Uniq -> Name | Source

mkNameU :: String -> Uniq -> Name | Source

tupleTypeName :: Int -> Name | Source

tupleDataName :: Int -> Name | Source

type OccName = PackedString | Source

mkOccName :: String -> OccName | Source

occString :: OccName -> String | Source

type ModName = PackedString | Source

mkModName :: String -> ModName | Source

modString :: ModName -> String | Source

type PkgName = PackedString | Source

mkPkgName :: String -> PkgName | Source

pkgString :: PkgName -> String | Source

Produced by Haddock version 0.9